#ifndef __B2T_H__
#define __B2T_H__
      
#ifdef  __cplusplus
extern "C"
{
#endif

// 바이너리 형식의 파일(filename)을 읽어 들이고 리소스 핸들을 반환한다.
// 리턴값 : 성공시 리소스 핸들, 실패시 오류값
extern void *b2t_Open
(
  const char *Filename
);

// n번째 문자열을 가져온다.
extern char *b2t_GetString
(
  void	*Rsc,
  int		N
);

// 리소스에 할당된 메모리를 해제한다.
extern int b2t_Close
(
  void	*Rsc
);

// 저장된 문자열의 수를 반환한다.
extern int b2t_GetStringCount
(
  void	*Rsc
);

// 텍스트 형식의 파일(input_filename)을 바이너리 형식의 파일(output_filename)으로 변환한다.
extern int b2t_Save
(
  const char *Input_filename,
  const char *Output_filename
);

// 오류값 정의
#define B2TeNULL_DICNAME              -2006070700
#define B2TeNOTEXIST_FILE             -2006111800
#define B2TeNO_MORE_HANDLE            -2006070701
#define B2TeINVALID_HANDLE            -2006070702
#define B2TeNOT_INITIALIZED           -2006070703
#define B2TeNOT_ENOUGH_MEMORY         -2007021300
#define B2TeMMAP_FAILED               -2007021301
#define B2TeMUNMAP_FAILED             -2007021302
#define B2TeNO_ENTRY                  -2007021303

#ifdef  __cplusplus
}
#endif
#endif
