/*
 *      이름 :  binio.h
 *      날짜 :  2007.02.20
 *      설명 :
 *      주의 :
 *      작성 :  이도길
 */
      
#ifndef __BINIO_H__
#define __BINIO_H__
      
#ifdef  __cplusplus
extern "C"
{
#endif

//바이너리 형식의 파일(filename)을 읽어 들이고 리소스 구조체의 포인터를 반환한다.
//리턴값은 성공시 구조체 포인터, 실패시 NULL이다.
extern void *bin_Open
(
  const char *Filename
);

// 리소스 구조체에 할당된 메모리를 해제한다.
// 리턴값은 성공시 1, 실패시 0이다.
extern int bin_Close
(
  void *Rsc
);

// 리소스에 포함된 전체 엔트리의 수를 반환한다.
extern int bin_GetCount
(
  void *Rsc,
  int SizeOfData // [input] 자료형의 크기  
);

// 리소스에서 n번째 정수 엔트리를 가져온다.
extern int bin_GetEntryInt
(
  void *Rsc,
  int N
);

// 리소스에서 n번째 정수 엔트리를 가져온다.
extern float bin_GetEntryFloat
(
  void *Rsc,
  int N
);

// 리소스에서 n번째 실수 엔트리를 가져온다.
extern double bin_GetEntryDouble
(
  void *Rsc,
  int N
);

// 리소스에서 n번째 엔트리를 가져온다.
// Callback은 사용자 콜백 함수
extern void *bin_GetEntry
(
  void *Rsc,
  int N, 
  void *(*Callback)(void *, int)
);

// 오류값 정의
      
#ifdef  __cplusplus
}
#endif
#endif
