#ifndef __SORT_UNIQ_H__
#define __SORT_UNIQ_H__

#ifdef  __cplusplus
extern "C"
{
#endif

// 입력된 화일(file_name)을 라인별로 저장
// 각 라인은 EntryTable로 접근할 수 있다.
// 함수 내부에서 메모리를 할당하므로, 더 이상 EntryTable을 사용하지 않게 되면
// free(EntryTable)을 외부에서 해 줘야 한다.
// 리턴값 : 라인의 수
// EntryTable : 입력 라인들의 포인터
extern int su_FILEtoLINES
(
  const char	*FileName,
  char		***EntryTable,
  char		**Entry
);

// sort a file
// return value : 1 (success), -1 (failure)
// stdout에 출력
extern int su_SortFile
(
	const char	*InputFileName,	// [input]
	FILE		*OutFp		// [output]
);

// sort & uniq a file
// return value : 1 (success), -1 (failure)
extern int su_SortAndUniqFile
(
	const char *InputFileName,	// [input]
	FILE		*OutFp		// [output]
);

// sort & uniq a file (단, 빈도가 N 이상인 경우만 출력)
// return value : 1 (success), -1 (failure)
extern int su_SortAndUniqFileCutoff
(
	const char *InputFileName,	// [input]
	int		N,			// [input]
	FILE		*OutFp		// [output]
);

// sort & uniq a file (단, 빈도도 함께 출력)
// return value : 1 (success), -1 (failure)
extern int su_SortAndUniqFileWithFreq
(
	const char	*InputFileName,	// [input]
	FILE		*OutFp		// [output]
);


#ifdef  __cplusplus
}
#endif
#endif
